######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/events.4gl  1.2  Delta: 1/4/91
######################################################################

globals "globals.4gl"

######################################################################
function event_prc(act_key,p_funct)
# returning true if it knows about the internal event
######################################################################
# This function processes all of the known internal events.
#
    define
        act_key char(15),       # Action to process
        p_funct char(15)        # Current function name

    # Trap fatal errors
    whenever error call error_handler

    # Process known (hardcoded) event codes
    case
      when act_key = "navigate" call fg_navigate()
      when act_key = "help" call scr_help()
      when act_key = "hot" call hot_browse()
      when act_key = "info" call fg_info()
      when act_key = "notes"
        if get_scrlib("scr_type") = "zoom"
        then
            call key_zedit("notes")
        else
            call key_edit("notes")
            if note_exist(get_scrlib("scr_tab"), get_scrlib("scr_key"))
              then call lib_message("note_on")
              else call lib_message("note_off")
            end if
        end if
      when act_key = "udf"
        if get_scrlib("scr_type") = "zoom"
          then call key_zedit("udf")
          else call key_edit("udf")
        end if
      when act_key = "ack" call fg_ack()
      when act_key = "status" call er_status()
      when act_key = "feature" call fg_feature()
      when act_key = "bang" call ring_bang()
      when act_key = "errbrws" call fg_err(0)
      when act_key = "todo" call fg_todo()
      when act_key = "funct_edit" call fg_fedit(p_funct)
      otherwise return false
    end case

    # The linker needs to have the following functions
    # specified somewhere in this library.  These calls are here
    # simply to fake those brain dead linkers that make only
    # one pass through the library list.
    if false
    then
        call wait_on()
        call wait_off()
        call mustfill()
        call global_events()
        if help_menu("","",0,"","",0,0) then end if
        call eror_menu("","",0)
    end if

    return true

end function
# event_prc.4gl
