########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/fg_fr.4gl  1.4  Delta: 3/23/91
########################################################################

# This 4GL module contains the functions necessary for the
# user to enter feature requests to the errlog.

globals "globals.4gl"

define
    arr_mesgs array[6] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)                  # Y/null Message cursor prepared?


######################################################################
function fg_feature()
######################################################################
# This function calls the error log's editor - allowing the user
# to enter a feature request & log it into the errlog.
#
    define

    nl char(1)   # storage for the newline character

    # Trap fatal errors
    whenever error call error_handler

    # initialize embedded messages/displays
 
#-------------------------------------------------

    if mssg_prep is null then
       #1:    "=========================================="
       call fg_getmsg("lib_scr","feature",1)
       let arr_mesgs[1].mssg_text = scratch 
       #2:    "Please disregard the \"Date: Time:\" lines."
       call fg_getmsg("lib_scr","feature",2)
       let arr_mesgs[2].mssg_text = scratch 
       #3:    "They are a by-product of I4GL errorlog()."
       call fg_getmsg("lib_scr","feature",3)
       let arr_mesgs[3].mssg_text = scratch 
       #4:    "Feature request log.  Requested by:  "
       call fg_getmsg("lib_scr","feature",4)
       let arr_mesgs[4].mssg_text = scratch 
       #5:    "Software Feature Request"
       call fg_getmsg("lib_scr","feature",5)
       let arr_mesgs[5].mssg_text = scratch 
       #6:    "End of feature request log"
       call fg_getmsg("lib_scr","feature",6)
       let arr_mesgs[6].mssg_text = scratch 
       let mssg_prep = "Y"
    end if

    let nl = "\n"
    let scratch =
     arr_mesgs[1].mssg_text clipped,nl,
     arr_mesgs[2].mssg_text clipped,nl,
     arr_mesgs[3].mssg_text clipped,nl,nl,
     arr_mesgs[4].mssg_text clipped, fg_username(), nl

    call errorlog(scratch[1,512])

    call textinit()
    call texthelp("lib_scr","fr",1)
    call textdefault("feature request")
    call er_edit(arr_mesgs[5].mssg_text clipped)

    let scratch = arr_mesgs[6].mssg_text clipped, nl, 
                  arr_mesgs[1].mssg_text clipped, nl
    call errorlog(scratch[1,512])

end function
# fg_feature()
