########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/fg_info.4gl  1.4  Delta: 3/23/91
########################################################################

# This 4GL module contains the functions necessary for the
# Information Picker.

globals "globals.4gl"

define
    arr_mesgs array[6] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)                  # Y/null Message cursor prepared?

######################################################################
function fg_info()
######################################################################
# This function opens a picker window for the known User Interface
# level functions.
#
    define
       scr_key char(30)

    # Trap fatal errors
    whenever error call error_handler

    if mssg_prep is null then
#1:    "Acknowledgements"
       call fg_getmsg("lib_scr","info",1)
       let arr_mesgs[1].mssg_text = scratch
#2:    "Feature Requests"
       call fg_getmsg("lib_scr","info",2)
       let arr_mesgs[2].mssg_text = scratch
#3:    "Program Status"
       call fg_getmsg("lib_scr","info",3)
       let arr_mesgs[3].mssg_text = scratch
#4:    "Navigate Menu"
       call fg_getmsg("lib_scr","info",4)
       let arr_mesgs[4].mssg_text = scratch
#5:    "Hot Keys Menu"
       call fg_getmsg("lib_scr","info",5)
       let arr_mesgs[5].mssg_text = scratch
#6:    "Program Information"
       call fg_getmsg("lib_scr","info",6)
       let arr_mesgs[6].mssg_text = scratch
       let mssg_prep = "Y"
     end if

    let scr_key = get_scrlib("scr_key")
    call textput(arr_mesgs[1].mssg_text)
    call textput(arr_mesgs[2].mssg_text)
    call textput(arr_mesgs[3].mssg_text)
    call textput(arr_mesgs[4].mssg_text)
    call textput(arr_mesgs[5].mssg_text)

    call texthelp("lib_scr","fg_info",1)
    if textpick(arr_mesgs[6].mssg_text) > 0
    then
        case
          when scratch = arr_mesgs[1].mssg_text call fg_ack()
          when scratch = arr_mesgs[2].mssg_text call fg_feature()
          when scratch = arr_mesgs[3].mssg_text call er_status()
          when scratch = arr_mesgs[4].mssg_text call fg_navigate()
          when scratch = arr_mesgs[5].mssg_text call hot_browse()
        end case
    end if

end function
# fg_info()
