######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/filt_ord.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

######################################################################
function lib_filtord()
######################################################################
# This function defaults the sql_filter to "1=1" if null,
# and inserts the " order by" clause into sql_order if it
# doesn't exist in sql_order already.
#
    # Trap fatal errors
    whenever error call error_handler

    # Default sql_filter to "1=1" if appropriate
    if sql_filter = " " or sql_filter is null
      then let sql_filter = "1=1"
    end if

    # Insert the " order by " clause in sql_order if not already there
    if    sql_order is not null
      and sql_order != " "
      and sql_order[1,9] != " order by"
    then
        # Downshifted to alter "DESC" into "desc"
        # SQL is not case sensitive anyway.
        let scratch = downshift(sql_order)
        let sql_order = " order by ", scratch clipped
    end if
end function
# lib_filtord()
