######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/get_mod.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

define
   p_module char(8),   # Module name
   p_program char(8)   # Program name

######################################################################
function get_mod()
# returns module and program name
######################################################################
# This function determines the module and program name.  If the
# module is stored in the scrlib, then it returns that one (the
# module stored in scrlib changes upon calls to zoom screens).
# If the module in scrlib is null (not set in a zoom init function),
# then it returns the one found in the first part of progid
# ("module.program").
#
    define
        l_mod char(8),   # local module name
        n smallint       # counter

    # Trap fatal errors
    whenever error call error_handler

    # Determine module/program upon first call
    if p_program is null
    then
        # Search for the period delimiter
        for n = 1 to 9
            if progid[n] = "."
            then
                let p_module = progid[1,n-1]
                let p_program = progid[n+1,17]
            end if
        end for

        # Delimiter not found
        if p_program is null then let p_program = progid end if
    end if

    # See if module is in the scrlib
    let l_mod = get_scrlib("module")
    if l_mod is null or l_mod = " "
      then let l_mod = p_module
    end if

    # Return the correct module name, and the program id
    return l_mod, p_program
    
end function
