######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/init.4gl  1.6  Delta: 1/22/91
######################################################################

globals "globals.4gl"

######################################################################
function init()
######################################################################
#
    define
        n smallint,      # Generic
        dbname char(18)  # Database name

    # Trap fatal errors
    whenever error call error_handler

    options input wrap
    options prompt line first + 1
    options form line first + 3
    call logo()
    call startlog("errlog")
    let menu_item = "init"

    # Check for -c flag used by FourGen accounting to specify
    # the database. Needs to be here to assure that mktables
    # is run on the correct database. We check for -d after
    # -c to insure that non-FourGen accounting programs may use the
    # -c flag for uses other than to specify the company (database).
    if get_arg("-c")
    then
        call put_scrlib("dbname","(see scratch)")
    end if

    # Check for the database name on the command line
    if get_arg("-d")
    then
        call put_scrlib("dbname","(see scratch)")
    end if

    # If we don't have the database name by now,
    # then we're going to have to prompt the user for it (ouch)
    # but that's our only way of knowing...
    let scratch = get_scrlib("dbname")
    if length(scratch) = 0
    then
        while true
          display "The database has not been specified."
            at 1,2
          prompt "Enter your database name: " for scratch
          if int_flag then exit program(1) end if
          if scratch is not null and scratch != " "
            then exit while
          end if
        end while
        call put_scrlib("dbname","(see scratch)")
    end if

    # Open the correct database
    let dbname = get_scrlib("dbname")
    database dbname

    # Set isolation level for online/turbo database
    if is_turbo()
    then
        set isolation to dirty read
    end if

    # Check to see if the most recent schema has been installed
    # onto this database.
    # Latest change: addition of the cgxsorcd table.
    select count(*) into n from systables where tabname = "cgxsorcd"
    if n = 0
    then
        # Install the tables
        call fg_tables()
    end if

    # Set the language variable
    if get_arg("-l") = false
      then let scratch = "ENG"
    end if
    call put_scrlib("language","(see scratch)")

    # Default some values
    if get_scrlib("auto_udf") is null
      then call put_scrlib("auto_udf","Y")
    end if
    if get_scrlib("auto_note") is null
      then call put_scrlib("auto_note","N")
    end if

    # We have to have a call to event_prc() somewhere in this
    # library to assure that all events are linked into the
    # program.  Because this init() function is always called,
    # it is a sure bet that the linker will find the call here.
    if false
      then if event_prc("","") then end if
    end if

end function
# init()
