######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/k_edit.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

######################################################################
function key_edit(funct)
######################################################################
# This function is called when the user requests to edit data that
# is tied to the key of this document.
#
    define
        funct char(10),       # edit function
        tabname char(18),     # main table for this screen
        tabkey char(30),      # the key to the table
        uniq_no integer       # a unique number

    # Trap fatal errors
    whenever error call error_handler

    # Find the main table name for this document
    let tabname = get_scrlib("scr_tab")
    if tabname is null or tabname = " "
    then
        call lib_error("lib_scr","key_edit",1,"no mlh_key() type function")
        return
    end if

    # Define a unique table key if it hasn't been defined yet
    let tabkey = get_scrlib("scr_key")

    # Generate a unique key if necessary
    if tabkey is null or tabkey = " " or tabkey = "0"
    then
        # Don't generate a unique key unless we're updating a screen
        # (in add or update mode)
        if menu_item = "add" or menu_item = "update"
          then else return
        end if
        let uniq_no = al_uniq()
        let tabkey = uniq_no using "Temp Key: <<<<<<<<<<"
        call put_scrlib("scr_key",tabkey)
    end if

    # Call the appropriate editing function
    case
      when funct = "udf" call udf_edit(tabname, tabkey)
      when funct = "notes" call note_edit(tabname, tabkey)
    end case

end function
# key_edit()
