######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/l_getkey.4gl  1.2  Delta: 3/6/91
######################################################################

globals "globals.4gl"

######################################################################
function lib_getkey()
######################################################################
# This function is called to define the key to the screen.
# It's main purpose is to set the scr_tab and scr_key variables.
#
    define
        tabname char(18),     # main table for this screen
        tabkey char(30),      # the key to the table
        c char(1),            # temporary char variable
        n smallint            # generic number

    # Trap fatal errors
    whenever error call error_handler

    if menu_item = "find" or menu_item = "browse"
    then
       call mlh_key()
    else
       call switchbox("build key")
    end if
    if scratch = "no function" then return end if
    let tabname = get_vararg()

    let tabkey = ""
    let n = num_vararg() - 1
    whenever error continue
    while n > 0
        let c = get_vararg()  # don't need the column name
        let status = 0
        let tabkey = tabkey clipped, get_vararg()
        # check for too long of a key
        if status = -4401
        then
            call lib_error("lib_scr","lib_key",1,"")
            let tabkey = ""
            exit while
        end if
        let n = n - 2
    end while
    whenever error call error_handler
    call put_scrlib("scr_tab",tabname)
    call put_scrlib("scr_key",tabkey)
end function
# lib_getkey()
