######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/l_newkey.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

######################################################################
function lib_newkey()
######################################################################
# This function is called to determine if the key has changed, and
# if so, it calls the "change key" function for all items tied to
# the document key.
#
    define
        upd_tab char(18),
        old_key char(30),
        upd_key char(30)

    # Trap fatal errors
    whenever error call error_handler

    # Retreive the table and keys from the library
    let upd_tab = get_scrlib("scr_tab")
    let old_key = get_scrlib("scr_key") # retreive the old key
    call lib_getkey()                   # build the new key
    let upd_key = get_scrlib("scr_key") # retreive the new key

    # If the new key is null and the old key is NOT null, then
    # either somebody blanked out the key during update, or
    # no key was entered and UDF or notes were used.  In either
    # case, we want to delete the UDF's and notes.  We can't use
    # them because we can't attach them to the document.
    if upd_key is null and old_key is not null
    then
        call udf_delete(upd_tab, old_key)
        call note_delete(upd_tab, old_key)
    else
        # Check for a difference in old/new keys & call newkey
        if  old_key = upd_key
         or (old_key is null and upd_key is null)
        then else
            call udf_newkey(upd_tab, old_key, upd_tab, upd_key)
            call note_newkey(upd_tab, old_key, upd_tab, upd_key)
        end if
    end if

end function
# lib_newkey()
