######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/l_order.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

######################################################################
function lib_order()
# returning the order by column
######################################################################
# This function takes the value of scratch, and returns the first
# word.  It is called after a construct statement to return the
# first column specified in the construct for ordering purposes.
#
    define
        c char(1),           # character storage
        n smallint           # temporary variable

    # Trap fatal errors
    whenever error call error_handler

    # User selected no order criteria
    if scratch = " 1=1" then return "" end if

    # Return the first word of the construct clause
    for n = 1 to length(scratch)
        let c = scratch[n,n]
        if  c = " " or c = "=" or c = "<" or c = ">"
          then return scratch[1,n-1]
        end if
    end for

    # Error condition (scratch is null)
    return ""
end function
# lib_order()
