######################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/menueror.4gl  1.3  Delta: 1/4/91
######################################################################

globals "globals.4gl"

######################################################################
function eror_menu(ere_mod,ere_prog,ere_num)
######################################################################
# This is the menu interface from the zoom into an error. It is called
# from the user_ctl libraries.
# It is to be modified for other languages by copying the
# "menu to end menu" logic and adding more case statement
# values such as German "GRM", French "FRN", etc.
#
# The separate "modules" such as this allow for the various menus to
# be accessed from a applications local directory for "menu" command
# modifications. These would include the deletions of menu_item
# commands or the addition new menu-items.
#
# Add other language case values here and copy the menu through end
# menu logic here.  CHANGE THE COMMAND OPTIONS, THE PROMPT, AND
# ALL LABELS.
#

    define
        ere_mod     char(8),    # module name (entered)
        ere_prog    char(8),    # program name (entered)
        ere_num     smallint,   # error number (entered)
        menu_lang   char(3)     # language value loads into here

    # Trap fatal errors
    whenever error call error_handler

    # Get the language value
    let menu_lang = get_scrlib("language")

    case
    # Add other language case values here and copy the menu through end
    # menu logic here.  CHANGE THE COMMAND OPTIONS, THE PROMPT, AND
    # ALL LABELS.
    #
    # Example: when menu_lang = "GRM"

    # Bogus "when" to make "case" syntactically correct
    when menu_lang = "BOGUS"

    # Default language is Engligh (ENG)
    otherwise
    menu " Action"
        command key (t,v)
            "View" " Scroll through the error text"
            label tab:
            call lib_message("scroll")
            call er_mn_display()

        command key (control-c)
            # copy from another text...
            let int_flag = 0
            prompt " COPY: Enter module to copy from: " for ere_mod
            if int_flag != 0 then continue menu end if
            prompt " COPY: Enter program name: " for ere_prog
            if int_flag != 0 then continue menu end if
            prompt " COPY: Enter error number: " for ere_num
            if int_flag != 0 then continue menu end if
            call er_read(ere_mod, ere_prog, ere_num)
            call er_display()
            call er_update()

        command "Update" " Update error text"
            label m_update:
            call er_update()

        command "Status" " Display the technical status of the program"
            call er_status()

        command "Log" " Output this error to the system log"
            call er_log()

        command key ("!")
            call ring_bang()

        command key (e,x,q,interrupt) "Quit" " Return to the program"
            label cancel:
            exit menu

      # Event trapping logic
      command key (control-b) let hotkey = 2  goto event
      command key (control-e) let hotkey = 5  goto event
      command key (control-f) let hotkey = 6  goto event
      command key (control-g) let hotkey = 7  goto event
      command key (control-i) let hotkey = 9  goto event
      command key (control-n) let hotkey = 14 goto event
      command key (control-o) let hotkey = 15 goto event
      command key (control-p) let hotkey = 16 goto event
      command key (control-t) let hotkey = 20 goto event
      command key (control-u) let hotkey = 21 goto event
      command key (control-v) let hotkey = 22 goto event
      command key (control-w) let hotkey = 23 goto event
      command key (control-y) let hotkey = 25 goto event
      command key (control-z) let hotkey = 26 goto event
      command key (f1)  let hotkey = 101 goto event
      command key (f2)  let hotkey = 102 goto event
      command key (f3)  let hotkey = 103 goto event
      command key (f4)  let hotkey = 104 goto event
      command key (f5)  let hotkey = 105 goto event
      command key (f6)  let hotkey = 106 goto event
      command key (f7)  let hotkey = 107 goto event
      command key (f8)  let hotkey = 108 goto event
      command key (f9)  let hotkey = 109 goto event
      command key (f10) let hotkey = 110 goto event
      command key (f11) let hotkey = 111 goto event
      command key (f12) let hotkey = 112 goto event
      command key (f13) let hotkey = 113 goto event
      command key (f14) let hotkey = 114 goto event
      command key (f15) let hotkey = 115 goto event
      command key (f16) let hotkey = 116 goto event
      command key (f34) let hotkey = 134 goto event
      command key (f35) let hotkey = 135 goto event
      command key (f36) let hotkey = 136 goto event

      label event:
        call hot_local("help")
        call hot_key("er_info")
        case
          when scr_funct = "tab" or scr_funct = "btab" goto tab
          when scr_funct = "m_update" goto m_update
          when scr_funct = "accept" exit menu
          when scr_funct = "cancel" exit menu
          when scr_funct = "help" call lib_help("lib_scr","er_info",1)
        end case

    end menu

    end case

    return
end function
# eror_menu()
