######################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/menuhelp.4gl  1.3  Delta: 1/4/91
######################################################################

globals "globals.4gl"

######################################################################
function help_menu(hlp_mod,hlp_prog,hlp_num,ere_mod,ere_prog,
ere_num,do_info)
######################################################################
# This is the menu interface from the help screen. It is called
# from the user_ctl libraries.
# It is to be modified for other languages by copying the 
# "menu to end menu" logic and adding more case statement 
# values such as German "GRM", French "FRN", etc.
#
# The separate "modules" such as this allow for the various menus to 
# be accessed from a applications local directory for "menu" command
# modifications. These would include the deletions of menu_item command 
# or the addition new menu-items.
#
# Add other language case values here and copy the menu through end
# menu logic here.  CHANGE THE COMMAND OPTIONS, THE PROMPT, AND
# ALL LABELS.
#

    define
        hlp_mod     char(18),   # module name
        hlp_prog    char(18),   # program name within the module
        hlp_num     smallint,   # help number within the program
        ere_mod     char(18),   # module name (entered)
        ere_prog    char(18),   # program name (entered)
        ere_num     smallint,   # error number (entered)
        do_info     smallint,   # (boolean) Info menu selected?
        menu_lang   char(3)     # language value loads into here

    # Trap fatal errors
    whenever error call error_handler

    # Get the language value
    let menu_lang = get_scrlib("language")

    case
    # Add other language case values here and copy the menu through end
    # menu logic here.  CHANGE THE COMMAND OPTIONS, THE PROMPT, AND
    # ALL LABELS.
    #
    # Example: when menu_lang = "GRM"

    # Bogus "when" to make "case" syntactically correct
    when menu_lang = "BOGUS"

    # Default value is english (ENG)
    otherwise
    menu " Help"
        command "Info" " Request program information"
            label m_info:
            let do_info = true
            exit menu

        command key (v)
            "View" " Scroll through the help text"
            label tab:
            call lib_message("scroll")
            call help_m_disp()
            let int_flag = 0

        command key (control-c)
            # copy from another text...
            let int_flag = 0


            prompt " COPY: Enter module to copy from: " for ere_mod
            if int_flag != 0 then continue menu end if
            prompt " COPY: Enter program name: " for ere_prog

            if int_flag != 0 then continue menu end if
            prompt " COPY: Enter help number: " for ere_num
            if int_flag != 0 then continue menu end if
            call help_read(ere_mod, ere_prog, ere_num)
            call help_update(hlp_mod, hlp_prog, hlp_num)

        command "Update" " Update help text"
            label m_update:
            call help_update(hlp_mod, hlp_prog, hlp_num)

        command key ("!")
            call ring_bang()

        command key (e,x,q,interrupt) "Quit" " Return to the program"
            exit menu

      # Event trapping logic
      command key (control-b) let hotkey = 2  goto event
      command key (control-e) let hotkey = 5  goto event
      command key (control-f) let hotkey = 6  goto event
      command key (control-g) let hotkey = 7  goto event
      command key (control-i) let hotkey = 9  goto event
      command key (control-n) let hotkey = 14 goto event
      command key (control-o) let hotkey = 15 goto event
      command key (control-p) let hotkey = 16 goto event
      command key (control-t) let hotkey = 20 goto event
      command key (control-u) let hotkey = 21 goto event
      command key (control-v) let hotkey = 22 goto event
      command key (control-w) let hotkey = 23 goto event
      command key (control-y) let hotkey = 25 goto event
      command key (control-z) let hotkey = 26 goto event
      command key (f1)  let hotkey = 101 goto event
      command key (f2)  let hotkey = 102 goto event
      command key (f3)  let hotkey = 103 goto event
      command key (f4)  let hotkey = 104 goto event
      command key (f5)  let hotkey = 105 goto event
      command key (f6)  let hotkey = 106 goto event
      command key (f7)  let hotkey = 107 goto event
      command key (f8)  let hotkey = 108 goto event
      command key (f9)  let hotkey = 109 goto event
      command key (f10) let hotkey = 110 goto event
      command key (f11) let hotkey = 111 goto event
      command key (f12) let hotkey = 112 goto event
      command key (f13) let hotkey = 113 goto event
      command key (f14) let hotkey = 114 goto event
      command key (f15) let hotkey = 115 goto event
      command key (f16) let hotkey = 116 goto event
      command key (f34) let hotkey = 134 goto event
      command key (f35) let hotkey = 135 goto event
      command key (f36) let hotkey = 136 goto event

      label event:
        call hot_local("help")  # Prevent recursive calls to help
        call hot_key("lib_help")
        case
          when scr_funct = "tab" or scr_funct = "btab" goto tab
          when scr_funct = "m_update" goto m_update
          when scr_funct = "m_info" goto m_info
          when scr_funct = "accept" exit menu
          when scr_funct = "cancel" exit menu
        end case

    end menu

    end case
 
    return do_info
end function
# help_menu()
