######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/menuoptn.4gl  1.3  Delta: 1/4/91
######################################################################

globals "globals.4gl"

######################################################################
function optn_menu(ring_rowid, ring_cursor, ring_total)
# returning ring_rowid, ring_cursor, ring_total
######################################################################
#  this is the function that is called when "Options" is selected
#  from the menu.  it is passed the "ring_" variables and returns them
#  to the calling function "ring_options".
#
# It is to be modified for other languages by copying the
# "menu to end menu" logic and adding more case statement values such as
# German "GRM", French "FRN", etc.
#
# The separate "modules" such as this allow for the various menus to
# be accessed from a applications local directory for "menu" command
# modifications. These would include the deletions of menu_item
# commands or the addition new menu-items.
#
# Add other language case values here and copy the menu through end
# menu logic here.  CHANGE THE COMMAND OPTIONS, THE PROMPT, AND
# ALL LABELS.
#
    define
        ring_rowid  integer,    # the rowid of the current document
                                # (or -1 if no document is displayed)
        ring_cursor integer,    # the absolute address of the cursor
                                # (0 if document isn't part of the
                                # current cursor group)
        ring_total  integer,    # total number of elements in the cursor

        menu_lang   char(3)  # language value loads into here

    # Trap fatal errors
    whenever error call error_handler

    # Get the language value
    let menu_lang = get_scrlib("language")

    case
    # Add other language case values here and copy the menu through end
    # menu logic here.  CHANGE THE COMMAND OPTIONS, THE PROMPT, AND
    # ALL LABELS.
    #
    # Example: when menu_lang = "GRM"

    # Bogus "when" to make "case" syntactically correct
    when menu_lang = "BOGUS"

    # Default value is english (ENG)
    otherwise
    menu " Options"
        command "Info" " Request program information"
            label m_info:
            call fg_info()
            exit menu
        command "Sort" " Change the order of the documents"
            label m_sort:
            call ring_sort(ring_rowid)
              returning ring_rowid, ring_cursor, ring_total
            exit menu
        command key (e,x,q,interrupt) "Quit" " Return to the main menu"
            label m_quit:
            let int_flag = 0
            exit menu

      # Event trapping logic
      command key (control-b) let hotkey = 2  goto event
      command key (control-e) let hotkey = 5  goto event
      command key (control-f) let hotkey = 6  goto event
      command key (control-g) let hotkey = 7  goto event
      command key (control-i) let hotkey = 9  goto event
      command key (control-n) let hotkey = 14 goto event
      command key (control-o) let hotkey = 15 goto event
      command key (control-p) let hotkey = 16 goto event
      command key (control-t) let hotkey = 20 goto event
      command key (control-u) let hotkey = 21 goto event
      command key (control-v) let hotkey = 22 goto event
      command key (control-w) let hotkey = 23 goto event
      command key (control-y) let hotkey = 25 goto event
      command key (control-z) let hotkey = 26 goto event
      command key (f1)  let hotkey = 101 goto event
      command key (f2)  let hotkey = 102 goto event
      command key (f3)  let hotkey = 103 goto event
      command key (f4)  let hotkey = 104 goto event
      command key (f5)  let hotkey = 105 goto event
      command key (f6)  let hotkey = 106 goto event
      command key (f7)  let hotkey = 107 goto event
      command key (f8)  let hotkey = 108 goto event
      command key (f9)  let hotkey = 109 goto event
      command key (f10) let hotkey = 110 goto event
      command key (f11) let hotkey = 111 goto event
      command key (f12) let hotkey = 112 goto event
      command key (f13) let hotkey = 113 goto event
      command key (f14) let hotkey = 114 goto event
      command key (f15) let hotkey = 115 goto event
      command key (f16) let hotkey = 116 goto event
      command key (f34) let hotkey = 134 goto event
      command key (f35) let hotkey = 135 goto event
      command key (f36) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_local("help")        # process help locally
        call hot_key("ring_options")  # Map the key to the event
        case
          when scr_funct = "cancel" exit menu
          when scr_funct = "m_info" goto m_info
          when scr_funct = "m_sort" goto m_sort
          when scr_funct = "m_quit" goto m_quit
          when scr_funct = "help" call fg_help(2)
        end case

    end menu

    end case

    return ring_rowid, ring_cursor, ring_total

end function
# optn_menu()
