######################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/menuzoom.4gl  1.3  Delta: 1/4/91
######################################################################

globals "globals.4gl"

######################################################################
function zoom_menu()
######################################################################
# This is the main menu interface for zoom screens.
# It is to be modified for other languages by copying the
# "menu to end menu" logic and adding more case statement
# values such as German "GRM", French "FRN", etc.
#
# The separate "modules" such as this allow for the various menus to
# be accessed from a applications local directory for "menu" command
# modifications. These would include the deletions of menu_item
# commands or the addition new menu-items.
#
# Add other language case values here and copy the menu through end
# menu logic here.  CHANGE THE COMMAND OPTIONS, THE PROMPT, AND
# ALL LABELS.
#
    define
        menu_lang   char(3)  # language value loads into here

    # Trap fatal errors
    whenever error call error_handler

    # Get the language value
    let menu_lang = get_scrlib("language")

    case
    # Add other language case values here and copy the menu through end
    # menu logic here.  CHANGE THE COMMAND OPTIONS, THE PROMPT, AND
    # ALL LABELS.
    #
    # Example: when menu_lang = "GRM"

    # Bogus "when" to make "case" syntactically correct
    when menu_lang = "BOGUS"

    # Default value is english (ENG)
    otherwise
    menu " Zoom"
      command "Find" " Select a group of rows"
        label m_find:
        let menu_item = "find"
        call lib_message("find")
        call switchbox("construct")
        if int_flag != 0 then exit menu end if
        let sql_filter = scratch
        if do_zoom(true) = false then exit menu end if
      command "Sort" " Change the order of the rows"
        label m_sort:
        let menu_item = "sort"
        call lib_message("sort")
        call switchbox("construct")
        if int_flag != 0 then exit menu end if
        let sql_order = lib_order()
        if do_zoom(true) = false then exit menu end if
      command "Tab" " Scroll through the rows"
        label tab:
        let menu_item = "tab"
        if do_zoom(false) = false then exit menu end if
      command key ("!")
        call ring_bang()
      command key (e,x,q,interrupt) "Quit" " Return to the application"
        label m_quit:
        let menu_item = "quit"
        let int_flag = -1
        exit menu

      # Event trapping logic
      command key (control-b) let hotkey = 2  goto event
      command key (control-e) let hotkey = 5  goto event
      command key (control-f) let hotkey = 6  goto event
      command key (control-g) let hotkey = 7  goto event
      command key (control-i) let hotkey = 9  goto event
      command key (control-n) let hotkey = 14 goto event
      command key (control-o) let hotkey = 15 goto event
      command key (control-p) let hotkey = 16 goto event
      command key (control-t) let hotkey = 20 goto event
      command key (control-u) let hotkey = 21 goto event
      command key (control-v) let hotkey = 22 goto event
      command key (control-w) let hotkey = 23 goto event
      command key (control-y) let hotkey = 25 goto event
      command key (control-z) let hotkey = 26 goto event
      command key (f1)  let hotkey = 101 goto event
      command key (f2)  let hotkey = 102 goto event
      command key (f3)  let hotkey = 103 goto event
      command key (f4)  let hotkey = 104 goto event
      command key (f5)  let hotkey = 105 goto event
      command key (f6)  let hotkey = 106 goto event
      command key (f7)  let hotkey = 107 goto event
      command key (f8)  let hotkey = 108 goto event
      command key (f9)  let hotkey = 109 goto event
      command key (f10) let hotkey = 110 goto event
      command key (f11) let hotkey = 111 goto event
      command key (f12) let hotkey = 112 goto event
      command key (f13) let hotkey = 113 goto event
      command key (f14) let hotkey = 114 goto event
      command key (f15) let hotkey = 115 goto event
      command key (f16) let hotkey = 116 goto event
      command key (f34) let hotkey = 134 goto event
      command key (f35) let hotkey = 135 goto event
      command key (escape, f36) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_local("help")    # Process help locally
        call hot_key("fcm_zoom")  # Map the key to the event
        case
          when scr_funct = "m_find" goto m_find
          when scr_funct = "m_sort" goto m_sort
          when scr_funct = "tab" or scr_funct = "btab" goto tab
          when scr_funct = "cancel" goto m_quit
          when scr_funct = "m_quit" goto m_quit
          when scr_funct = "help" call lib_help("lib_scr","zoom",1)
        end case

    end menu

    end case

    return
end function
# zoom_menu()
