########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/message.4gl  1.4  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    arr_mesgs array[38] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)                  # Y/null Message cursor prepared?

######################################################################
function lib_message(funct)
######################################################################
# This function displays the correct message for the function.
# Note:  Data may be passed in scratchpad, so don't call any
# function that changes scratch before the 'case' statement.
#
    define
        funct char(10),    # function to display
        n smallint,        # temporary variable
        help_min smallint, # minimum column no. to display help message
        num_rows smallint, # number of rows in the window
        num_cols smallint  # number of columns in the window

    # Trap fatal errors
    whenever error call error_handler

    # Initialize some variables
    let num_rows = get_scrlib("num_rows")
    let num_cols = get_scrlib("num_cols")
    let help_min = 100    # default: not enough room for help message

    if mssg_prep is null then
#1:"======" 
       call fg_getmsg("lib_scr","message",1)
       let arr_mesgs[1].mssg_text = scratch
#2:"(Zoom)" 
       call fg_getmsg("lib_scr","message",2)
       let arr_mesgs[2].mssg_text = scratch
#3:"=======" 
       call fg_getmsg("lib_scr","message",3)
       let arr_mesgs[3].mssg_text = scratch
#4:"(Notes)" 
       call fg_getmsg("lib_scr","message",4)
       let arr_mesgs[4].mssg_text = scratch
#5: "Sort:  [ESC] when done, [DEL] to Cancel"
       call fg_getmsg("lib_scr","message",5)
       let arr_mesgs[5].mssg_text = scratch
#6: "Enter ANY valid data into the column to sort by."
       call fg_getmsg("lib_scr","message",6)
       let arr_mesgs[6].mssg_text = scratch
#7: "Find:  [ESC] to Find, [DEL] to Cancel" 
       call fg_getmsg("lib_scr","message",7)
       let arr_mesgs[7].mssg_text = scratch
#8: "Enter selection criteria into form" 
       call fg_getmsg("lib_scr","message",8)
       let arr_mesgs[8].mssg_text = scratch
#9: "Zoom:  [ESC] to Select, [TAB] for Menu"
       call fg_getmsg("lib_scr","message",9)
       let arr_mesgs[9].mssg_text = scratch
#10: "[F3] or [F4] to Page,   [DEL] to Quit"
       call fg_getmsg("lib_scr","message",10)
       let arr_mesgs[10].mssg_text = scratch
#11: "Update: [ESC] to Store, [DEL] to Cancel"
       call fg_getmsg("lib_scr","message",11)
       let arr_mesgs[11].mssg_text = scratch
#12: "Enter changes into form" 
       call fg_getmsg("lib_scr","message",12)
       let arr_mesgs[12].mssg_text = scratch
#13: "Update:  [ESC] to Store," 
       call fg_getmsg("lib_scr","message",13)
       let arr_mesgs[13].mssg_text = scratch
#14: "[DEL] to Cancel"
       call fg_getmsg("lib_scr","message",14)
       let arr_mesgs[14].mssg_text = scratch
#15: "[ESC] to Store,"
       call fg_getmsg("lib_scr","message",15)
       let arr_mesgs[15].mssg_text = scratch
#16: "[DEL] to Cancel"
       call fg_getmsg("lib_scr","message",16)
       let arr_mesgs[16].mssg_text = scratch
#17: "Add:    [ESC] to Store, [DEL] to Cancel" 
       call fg_getmsg("lib_scr","message",17)
       let arr_mesgs[17].mssg_text = scratch
#18: "Enter changes into form"
       call fg_getmsg("lib_scr","message",18)
       let arr_mesgs[18].mssg_text = scratch
#19: "Add:  [ESC] to Store," 
       call fg_getmsg("lib_scr","message",19)
       let arr_mesgs[19].mssg_text = scratch
#20: "[DEL] to Cancel"
       call fg_getmsg("lib_scr","message",20)
       let arr_mesgs[20].mssg_text = scratch
#21: "[ESC] to Store,"
       call fg_getmsg("lib_scr","message",21)
       let arr_mesgs[21].mssg_text = scratch
#22: "[DEL] to Cancel"
       call fg_getmsg("lib_scr","message",22)
       let arr_mesgs[22].mssg_text = scratch
#23: ", [TAB] Next Window"
       call fg_getmsg("lib_scr","message",23)
       let arr_mesgs[23].mssg_text = scratch
#24: "Scroll:  [TAB], [DEL], or [ESC]  to Quit"
       call fg_getmsg("lib_scr","message",24)
       let arr_mesgs[24].mssg_text = scratch
#25: "[ARROW KEYS] to Scroll, [F3] or [F4] to Page"
       call fg_getmsg("lib_scr","message",25)
       let arr_mesgs[25].mssg_text = scratch
#26: "View:  [ESC] or" 
       call fg_getmsg("lib_scr","message",26)
       let arr_mesgs[26].mssg_text = scratch
#27: "[DEL] to Quit"
       call fg_getmsg("lib_scr","message",27)
       let arr_mesgs[27].mssg_text = scratch
#28: "Choose:  [ESC] to Select,"
       call fg_getmsg("lib_scr","message",28)
       let arr_mesgs[28].mssg_text = scratch
#29: "[ESC] to Select,"
       call fg_getmsg("lib_scr","message",29)
       let arr_mesgs[29].mssg_text = scratch
#30: "[DEL] to Quit" 
       call fg_getmsg("lib_scr","message",30)
       let arr_mesgs[30].mssg_text = scratch
#31: "Errors:  [CTRL]-[z] to View the Error,"
       call fg_getmsg("lib_scr","message",31)
       let arr_mesgs[31].mssg_text = scratch
#32: "[CTRL]-[n] for New,  [DEL] or [ESC] to Quit"
       call fg_getmsg("lib_scr","message",32)
       let arr_mesgs[32].mssg_text = scratch
#33: "Cursor Path: [ESC] to Store, [DEL] to Cancel," 
       call fg_getmsg("lib_scr","message",33)
       let arr_mesgs[33].mssg_text = scratch
#34: "[U] to Update, [ENTER] or [TAB] for Next Field"
       call fg_getmsg("lib_scr","message",34)
       let arr_mesgs[34].mssg_text = scratch
#35: "Help:     " 
       call fg_getmsg("lib_scr","message",35)
       let arr_mesgs[35].mssg_text = scratch
#36: "[CTRL]-[w]"
       call fg_getmsg("lib_scr","message",36)
       let arr_mesgs[36].mssg_text = scratch
#37: "Info:     " 
       call fg_getmsg("lib_scr","message",37)
       let arr_mesgs[37].mssg_text = scratch
#38: "[CTRL]-[y]"
       call fg_getmsg("lib_scr","message",38)
       let arr_mesgs[38].mssg_text = scratch
       let mssg_prep = "Y"
     end if

    case
      when funct = "zoom_off"
        let n = num_cols - 7
        if num_rows >= 3 then display arr_mesgs[1].mssg_text clipped
        at 3, n end if
      when funct = "zoom_on"
        let n = num_cols - 7
        if num_rows >= 3 then display arr_mesgs[2].mssg_text clipped
        at 3, n end if
      when funct = "note_off"
        let n = num_cols - 16
        if num_rows >= 3 then display arr_mesgs[3].mssg_text clipped
        at 3, n end if
      when funct = "note_on"
        let n = num_cols - 16
        if num_rows >= 3 then display arr_mesgs[4].mssg_text clipped
        at 3, n end if
      when funct = "sort"
        call ring_clear()
        display arr_mesgs[5].mssg_text clipped at 1,2
        display arr_mesgs[6].mssg_text clipped at 2,2
        clear form
      when funct = "find"
        call ring_clear()
        display arr_mesgs[7].mssg_text clipped at 1,2
        display arr_mesgs[8].mssg_text clipped at 2,2
        clear form
      when funct = "zoom"
        call ring_clear()
        let help_min = 40
        display arr_mesgs[9].mssg_text clipped at 1,2
        display arr_mesgs[10].mssg_text clipped at 2,2
        clear form
      when funct = "update"
        call ring_clear()
        case
          when num_cols > 41
            let help_min = 43
                display arr_mesgs[11].mssg_text clipped at 1,2
                display arr_mesgs[12].mssg_text clipped at 2,2
          when num_cols > 25
            let help_min = 27
                display arr_mesgs[13].mssg_text clipped at 1,2
                display arr_mesgs[14].mssg_text clipped at 2,2
          otherwise
                display arr_mesgs[15].mssg_text clipped at 1,2
                display arr_mesgs[16].mssg_text clipped at 2,2
        end case
      when funct = "add"
        call ring_clear()
        case
          when num_cols > 41
            let help_min = 43
                display arr_mesgs[17].mssg_text clipped at 1,2
                display arr_mesgs[18].mssg_text clipped at 2,2
          when num_cols > 22
            let help_min = 24
                display arr_mesgs[19].mssg_text clipped at 1,2
                display arr_mesgs[20].mssg_text clipped at 2,2
          otherwise
                display arr_mesgs[21].mssg_text clipped at 1,2
                display arr_mesgs[22].mssg_text clipped at 2,2
        end case
      when funct = "tab"
        # See if it will fit with "update" and "help" messages
        if num_cols > 72
                  then display arr_mesgs[23].mssg_text clipped at 1,41
        end if
      when funct = "scroll"
        call ring_clear()
        let help_min = 99
        display arr_mesgs[24].mssg_text clipped at 1,2
        display arr_mesgs[25].mssg_text clipped at 2,2
      when funct = "scr_bottom"
        if scratch[100,104] = "no cl"
          then let scratch[100,104] = " "
          else display "" at num_rows, 1
        end if
        let n = (num_cols / 2) - (length(scratch) / 2) + .99
        if n < 1 then let n = 1 end if
        display scratch clipped at num_rows, n
      when funct = "textview"
        call ring_clear()
        let help_min = 17
        display arr_mesgs[26].mssg_text clipped at 1,2
        display arr_mesgs[27].mssg_text clipped at 2,2
      when funct = "choose"
        call ring_clear()
        case
          when num_cols > 25
            let help_min = 27
            display arr_mesgs[28].mssg_text clipped at 1,2
          otherwise
            display arr_mesgs[29].mssg_text clipped at 1,2
        end case
        display arr_mesgs[30].mssg_text clipped at 2,2
      when funct = "errchose"
        call ring_clear()
        let help_min = 46
        display arr_mesgs[31].mssg_text clipped at 1,2
        display arr_mesgs[32].mssg_text clipped at 2,2
      when funct = "cur_path"
        call ring_clear()
        let help_min = 49
        display arr_mesgs[33].mssg_text clipped at 1,2
        display arr_mesgs[34].mssg_text clipped at 2,2
      when funct = "help"
        let help_min = 2
    end case

    # Display the help message (if there is enough room in this window)
    if num_cols > (help_min + 10)
    then
        let n = num_cols - 10
        if is_ucl()
        then
            display arr_mesgs[35].mssg_text clipped at 1, n
            display arr_mesgs[36].mssg_text clipped at 2, n
        else
            display arr_mesgs[37].mssg_text clipped at 1, n
            display arr_mesgs[38].mssg_text clipped at 2, n
        end if
    end if

end function
# lib_message()
