######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/mlh_lock.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

define
    is_prep smallint    # (boolean) has prepare statement been done?

######################################################################
function mlh_lock(row_id)
######################################################################
# This function opens a cursor for update selecting just the row
# defined by rowid.
# Because it fetches the record with an update cursor, the record
# is locked.
#
    define
        row_id integer,    # rowid of record to lock
        tab_name char(18), # browse table name
        getid integer      # something to fetch into

    # Trap fatal errors
    whenever error call error_handler

    # Prepare the locking SQL statement on first call to this function
    if is_prep = 123
    then else
        call mlh_cursor()
        let tab_name = get_vararg()
        let scratch = "select rowid from ", tab_name clipped,
          " where rowid = ? for update"
        prepare lock_spec from scratch
        declare lock_cursor cursor for lock_spec
        let is_prep = 123
    end if

    # Lock the row
    open lock_cursor using row_id
    whenever error continue
    fetch lock_cursor
    whenever error call error_handler
    return
end function
# mlh_lock()

#######################################################################
function mlh_unlock()
#######################################################################
#
    close lock_cursor
end function
# mlh_unlock()
