########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/os_exit.4gl  1.4  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    arr_mesgs array[2] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)               # Y/null Message cursor prepared?

######################################################################
function fg_os_exit(description, press_enter)
######################################################################
# This function runs an O/S command, and if press_enter is true,
# it prompts the user to press enter after the command is run.
# The command to run is passed in scratch.
#
# Messages:
#1: "Running:"
#2: " Press [ENTER] to continue. "
#
    define
        description char(60), # what to show upon running command
        cmd char(512),        # command storage
        press_enter smallint, # (boolean) Press [ENTER] upon return?
        c char(1)             # an input character

    # Trap fatal errors
    whenever error call error_handler

    # Save command from scratch
    let cmd = scratch

    # Initialize the messages
    if mssg_prep is null then
       call fg_getmsg("lib_scr","exitos",1)
       let arr_mesgs[1].mssg_text = scratch
       call fg_getmsg("lib_scr","exitos",2)
       let arr_mesgs[2].mssg_text =scratch
       let mssg_prep = "Y"
    end if

    # Open a window and tell what's going on
    if description is null then let description = cmd end if
    open window runwin at 2,3 with 2 rows, 76 columns attribute(white)
    display arr_mesgs[1].mssg_text clipped at 1,2
    display description at 1,12 attribute(red)
    call please_wait()

    # run the command and return
    run cmd
    if press_enter
      then prompt arr_mesgs[2].mssg_text clipped for char c
    end if
    close window runwin

end function
# fg_os_exit()
