######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_add.4gl  1.1  Delta: 11/23/90
######################################################################

######################################################################
function ring_add(lab_type, ring_rowid, ring_cursor, ring_total)
#   returning ring_rowid, ring_cursor, ring_total
######################################################################
#
    define
        lab_type    smallint, # label type: 1=header, 2=header/detail
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer

    # Trap fatal errors
    whenever error call error_handler

    # Database transactions
    if is_trx() then begin work end if

    # intelligent add routine
    if ok_add() = false
    then
        if is_trx() then rollback work end if
        return ring_rowid, ring_cursor, ring_total
    end if

    # clear out all data
    call lib_message("add")
    if lab_type = 2
      then call lib_message("tab")
    end if
    call lib_message("note_off")
    call mlh_clear()
    call mld_clear()
    call lld_display()
    call put_scrlib("scr_key","")      # no key defined yet
    call put_scrlib("curs_rowid","0")  # rowid = 0 for new document

    # in case of a previous error
    let status = 0
    let int_flag = 0

    # screen input function
    if ring_input() = -1
    then
        if is_trx() then rollback work end if
        call ring_view(ring_cursor)
            returning ring_rowid, ring_cursor
        return ring_rowid, ring_cursor, ring_total
    end if

    # pass control to the add function...
    # if it fails, it will return an sqlca.sqlcode < 0
    call ring_lladd(ring_rowid, ring_cursor, ring_total)
        returning ring_rowid, ring_cursor, ring_total

    # Commit/Rollback work if trx. used
    if is_trx()
    then
        if sqlca.sqlcode < 0
          then rollback work
          else commit work
        end if
    end if

    return ring_rowid, ring_cursor, ring_total
end function
# ring_add()
