########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_border.4gl  1.5  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    arr_mesgs array[4] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)                  # Y/null Message cursor prepared?
######################################################################
function ring_border(ring_rowid, ring_cursor, ring_total)
######################################################################
#   - draws the menu border
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer

    # Trap fatal errors
    whenever error call error_handler

    if mssg_prep is null then
#1: "(No Documents Selected)"
       call fg_getmsg("lib_scr","rborder",1)
       let arr_mesgs[1].mssg_text = scratch
#2: "(New Document)"
       call fg_getmsg("lib_scr","rborder",2)
       let arr_mesgs[2].mssg_text = scratch
#3: "(Deleted)"
       call fg_getmsg("lib_scr","rborder",3)
       let arr_mesgs[3].mssg_text = scratch
#4: " of"
       call fg_getmsg("lib_scr","rborder",4)
       let arr_mesgs[4].mssg_text = scratch
       let mssg_prep = "Y"
    end if

    # process the first border
    if ring_cursor = -1 and ring_total = -1
    then
        call menu_line()
        return
    end if

    # Print the "(Notes)" message if appropriate
    if note_exist(get_scrlib("scr_tab"), get_scrlib("scr_key"))
      then call lib_message("note_on")
      else call lib_message("note_off")
    end if

    # Something exists in the cursor
    if ring_total > 0 and ring_cursor > 0
    then
        let scratch = "(",ring_cursor using "<,<<<,<<<" clipped,
                        arr_mesgs[4].mssg_text clipped, " ",
                        ring_total using "<,<<<,<<<" clipped,")"
    end if

    # Nothing in the cursor
    if ring_total <= 0
      then let scratch = arr_mesgs[1].mssg_text clipped
    end if

    # Just added
    if ring_cursor = 0 and ring_rowid != -1
      then let scratch = arr_mesgs[2].mssg_text clipped
    end if

    # Append (Deleted)?
    if ring_rowid = 0
      then let scratch = scratch clipped,arr_mesgs[3].mssg_text clipped
    end if

    call lib_message("scr_bottom")

    # We have to have a call to event_prc() somewhere in this
    # library to assure that all events are linked into the
    # program.  Because this ring_border() function is almost always
    # called, it is a good bet that the linker will find event_prc here.
    if false
      then if event_prc("","") then end if
    end if

end function
# ring_border()
