######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_browse.4gl  1.2  Delta: 1/9/91
######################################################################

globals "globals.4gl"

######################################################################
function ring_browse(ring_rowid, ring_cursor, ring_total)
#   returning ring_rowid, ring_cursor, ring_total
######################################################################
#   browse sub-menu
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer,
        old_scr_id  char(7),   # holder for old scr_id value
        brw_window  smallint   # was the window browser used, or default

    # Trap fatal errors
    whenever error call error_handler

    # OK to browse?
    if ok_browse() = false
      then return ring_rowid, ring_cursor, ring_total end if

    # No need to browse if nothing to browse
    if ring_total <= 0
      then return ring_rowid, ring_cursor, ring_total end if

    # Blank screen entry into browse
    if ring_cursor = 0 then let ring_cursor = 1 end if

    # Save the current scr_id
    let old_scr_id = scr_id

    # Call either the local brw_hook (window browser), or the library
    # brw_hook (default browser) based on which one is loaded.
    # if brw_window = true, then the window browser was used, otherwise
    # the default browser was used.  this info isn't used at this time.

    call brw_hook(ring_rowid, ring_cursor, ring_total)
        returning brw_window, ring_rowid, ring_cursor, ring_total

    # Reset the scr_id
    let scr_id = old_scr_id

    return ring_rowid, ring_cursor, ring_total
end function
# ring_browse()
