########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_delete.4gl  1.4  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    arr_mesgs array[2] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)                  # Y/null Message cursor prepared?

######################################################################
function ring_delete(ring_rowid)
#   returning ring_rowid
######################################################################
#
    define
        ring_rowid  integer,
        yesno       char(1)

    # Trap fatal errors
    whenever error call error_handler

    if mssg_prep is null then
#1: "Delete:  Verify document deletion"
       call fg_getmsg("lib_scr","rdelete",1)
       let arr_mesgs[1].mssg_text = scratch
#2: " Erase this document? (Y/N) "
       call fg_getmsg("lib_scr","rdelete",2)
       let arr_mesgs[2].mssg_text = scratch
       let mssg_prep = "Y"
    end if

    # Disregard the rowid that is passed (retained as an argument
    # for backward compatibility only)
    let ring_rowid = get_scrlib("curs_rowid")

    # Check for already deleted
    if ring_rowid = 0
    then
        call fg_error("r_menu","r_delete",1)
        return ring_rowid
    end if

    # Check for no items in cursor
    if ring_rowid < 0
    then
        call fg_error("r_menu","r_delete",2)
        return ring_rowid
    end if

    # Database transactions
    if is_trx() then begin work end if

    # intelligent deletion routine
    if ok_delete() = false
    then
        if is_trx() then rollback work end if
        return ring_rowid
    end if

    call ring_clear()
    let int_flag = 0
    display arr_mesgs[1].mssg_text clipped at 1,2
    prompt arr_mesgs[2].mssg_text clipped for char yesno
    if yesno matches "[yY]" and int_flag = 0
    then
        # no-op
    else
        if is_trx() then rollback work end if
        let int_flag = 0
        return ring_rowid
    end if

    # read, and lock the record
    call mlh_lock(ring_rowid)
    if sqlca.sqlcode != 0
    then
        if status = notfound
        then
            # somebody has already deleted it.
            clear form
            let ring_rowid = -1
            call put_scrlib("curs_rowid",ring_rowid)
        else
            call fg_error("r_menu","r_delete",3)
        end if
        let status = 0
        if is_trx() then rollback work end if
        return ring_rowid
    end if

    call lld_delete()
    call llh_delete(ring_rowid)
    call lib_delkey()  # delete documents tied to this key
    call mlh_unlock()
    if is_trx() then commit work end if
    clear form
    call put_scrlib("curs_rowid",-1)
    return -1
end function
# ring_delete()
