######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_find.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

######################################################################
function ring_find(ring_rowid,ring_cursor,ring_total)
#   returning ring_rowid, ring_cursor, ring_total
######################################################################
# This function is run when "find" is selected from the ring menu.
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer,
        c char(1)             # input character

    # Trap fatal errors
    whenever error call error_handler

    # intelligent find routine
    if ok_find() = false
      then return ring_rowid, ring_cursor, ring_total
    end if

    call lib_message("find")
    clear form
    let int_flag = 0

    # define a new cursor
    let sql_filter = mlh_construct()
    if int_flag != 0
    then
        # decided against "find" command
        clear form
        let status = 0
        let int_flag = 0
        call ring_view(ring_cursor)
            returning ring_rowid, ring_cursor
        return ring_rowid, ring_cursor, ring_total
    end if

    # close the cursor if open.
    if ring_total > 0
    then
        call mlh_close_cur()
    end if

    # define the cursor/present the first record
    call ring_define(sql_filter)
        returning ring_rowid, ring_cursor, ring_total

    return ring_rowid, ring_cursor, ring_total
end function
# ring_find()

######################################################################
function ring_define(criteria)
# returning ring_rowid, ring_cursor, ring_total
######################################################################
#
    define
        criteria    char(512),  # construct criteria
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer

    # Database transactions
    if is_trx() then begin work end if

    call please_wait()
    call mlh_define_cur(criteria)

    # error if bad status, interrupt, or no rows processed
    if sqlca.sqlcode < 0 or sqlca.sqlerrd[3] = 0
    then
        clear form
        call mlh_clear()
        call llh_p_prep()
        call lib_getkey()
        let status = 0
        let ring_rowid = -1
        let ring_total = 0
        let ring_cursor = 0
        call put_scrlib("curs_rowid",ring_rowid)
        call put_scrlib("curs_count",ring_total)
        call put_scrlib("curs_pos",ring_cursor)
        if is_trx() then commit work end if
        return ring_rowid, ring_cursor, ring_total
    end if

    # cursor defined ok.
    let ring_total = sqlca.sqlerrd[3]
    call put_scrlib("curs_count",ring_total)

    # grab the first row of the cursor
    call ring_view(1) returning ring_rowid, ring_cursor

    # Transaction processing
    if is_trx() then commit work end if

    return ring_rowid, ring_cursor, ring_total
end function
# ring_define()
