######################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_header.4gl  1.2  Delta: 1/3/91
######################################################################

globals "globals.4gl"

######################################################################
function ring_header()
######################################################################
# This is the main ring_menu interface for header only screens.
#
    define
        ring_rowid  integer, # the rowid of the current screen record
                             # or -1 if there is no record on the screen
        ring_cursor integer, # pointer to the absolute cursor address.
                             # undefined for a closed cursor
        ring_total  integer  # total number of elements in the cursor.
                             # if ring_total > 0, then cursor is open.
                             # if ring_total = 0, then cursor is closed.
    # if ring_cursor is 0 and ring_total > 0, then there is a open
    # cursor, but the record on the screen doesn't have anything
    # to do with it.  (a newly added document)

    # Trap fatal errors
    whenever error call error_handler

    # Set the default screen id and window size
    let scr_id = "default"
    call window_size()

    # ring_border() with -1 arguments means to draw the first border
    call ring_border(-1, -1, -1)

    # Read in the default order clause
    if get_arg("order") then let sql_order = scratch end if

    # Call init function (placing the initial filter into scratch)
    let scratch = mlh_init()
    # Set scratch to filter passed on command line (if present)
    if get_arg("filter") then end if

    # Does the user wish to enter directly into the find mode?
    if get_arg("-f")
    then
        call ring_find(-1,0,0)
          returning ring_rowid, ring_cursor, ring_total
    else
        # load all elements into the cursor...
        if scratch = "1=0" or scratch = "1=2"
        then
            clear form
            call mlh_clear()
            call llh_p_prep()
            call lib_getkey()
            let ring_rowid = -1
            let ring_total = 0
            let ring_cursor = 0
            call put_scrlib("curs_rowid",ring_rowid)
            call put_scrlib("curs_count",ring_total)
            call put_scrlib("curs_pos",ring_cursor)
        else
            call ring_define(scratch[1,512])
                returning ring_rowid, ring_cursor, ring_total
        end if
    end if   
    call ring_border(ring_rowid, ring_cursor, ring_total)

    # Does the user wish to enter directly into the add mode?
    if get_arg("-a") or get_arg("-A")
    then
        call ring_add(1,-1, 0, 0)
          returning ring_rowid, ring_cursor, ring_total
        call ring_border(ring_rowid, ring_cursor, ring_total)
        # Want to exit now?
        if get_arg("-A") then return end if
    end if   

    # Does the user wish to enter directly into the update mode?
    if get_arg("-u") or get_arg("-U")
    then
        call ring_update(2,ring_rowid)
        call ring_border(ring_rowid, ring_cursor, ring_total)
        # Want to exit now?
        if get_arg("-U") then return end if
    end if   

# the following is the language independant menu routine in menuhead.4gl
# which is set up to allow different language menus to be utilized

    call head_menu(ring_rowid,ring_cursor,ring_total)

     let scr_funct = ""
     clear screen
     return
 end function
# ring_header()
