########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_input.4gl  1.5  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    arr_mesgs array[2] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1),                  # Y/null Message cursor prepared?

    prog_cancel char(1)  # Programatic "Y" or "N" for cancel.

######################################################################
function ring_input()
# returning -1 (delete) or 0 (good input)
######################################################################
#
    define
        ret_1value  smallint,       # function return values
        ret_2value  smallint        # function return values

    # Trap fatal errors
    whenever error call error_handler

    # Initialize some variables
    let scr_id = "default"
    call window_size()

    let int_flag = 0
    while true
        while true                  # process the header...
            let scr_fld = ""
            let input_num = 1
            call llh_input()
                returning ret_1value
            let scr_fld = ""
            if int_flag != 0
            then
                # Give user option to return
                let int_flag = 0
                # if no_cancel() then continue while end if
                clear form
                call lib_message("zoom_off")
                return -1
            end if
            call llh_chkinput()     # run "after input" processing
                returning ret_2value
            call llh_display()      # re-display all of the p_ variables
            call lib_message("zoom_off")
            if ret_2value = true    # input is ok.
            then
                if ret_1value = -1
                  then exit while      # tab key pressed.
                  else return 0        # save key pressed.
                end if
            end if
        end while                   # end of header processing

        while true                  # process the detail lines...
            let scr_fld = ""
            let input_num = 2
            let p_cur = 1
            let s_cur = 1
            call lld_input()
                returning ret_1value
            let scr_fld = ""
            call mld_arr_count()    # correctly sets rec1_cnt
            if int_flag != 0
            then
                # Give user option to return
                let int_flag = 0
                # if no_cancel() then continue while end if
                clear form
                call lib_message("zoom_off")
                return -1
            end if
            call lld_chkinput()     # validate input...
                returning ret_2value
            call lld_display()      # re-display all of the p_ variables
            call lib_message("zoom_off")
            if ret_2value = true    # input is ok.
            then
                if ret_1value = -1
                  then exit while      # tab key pressed.
                  else return 0        # save key pressed.
                end if
            end if
        end while                   # end of detail lines processing
    end while                       # end of main while true loop
end function
# ring_input()

######################################################################
function no_cancel()
# returning true if user didn't mean to cancel.
######################################################################
# This function asks the user if they really meant to press the
# cancel function key.  If they answer 'y' or press another cancel
# function key, then they will be placed back into the input.
#
    define
        c char(1)  # generic entry character

    if mssg_prep is null then
#1: "[DEL] Pressed:"
       call fg_getmsg("lib_scr","rinput",1)
       let arr_mesgs[1].mssg_text = scratch 
#2: " OK to Cancel? (y/n) "
       call fg_getmsg("lib_scr","rinput",2)
       let arr_mesgs[2].mssg_text = scratch
       let mssg_prep = "Y"
    end if

    let int_flag = false
    let c = downshift(prog_cancel)

    # Only ask the question if it hasn't
    # been programatically answered already.
    if prog_cancel is null
    then
        call wait_on("")
        display arr_mesgs[1].mssg_text clipped at 1,2
        prompt arr_mesgs[2].mssg_text clipped for char c
        call wait_off()
    end if

    let prog_cancel = null
    if int_flag or downshift(c) = "y"
    then
        let int_flag = false
        return false
    else
        return true
    end if

end function
# no_cancel()

######################################################################
function ok_cancel(answer)
######################################################################
# This function is called to programatically answer the question:
# "OK TO CANCEL?".  If you want to disable the [DEL] key, then you
# would call ok_cancel("N") in the 'before input' trigger.
# If you want to programatically cancel the input, but don't want
# the user to have to answer the "Ok to cancel?" question, then
# you could call ok_cancel("Y"), and let int_flag = -1, and 
# let nxt_fld = "exit input".
#
    define
        answer char(1)  # "Y" or "N" answer to question

    let prog_cancel = answer

end function
# ok_cancel()
