######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_lladd.4gl  1.1  Delta: 11/23/90
######################################################################

######################################################################
function ring_lladd(ring_rowid, ring_cursor, ring_total)
#   returning ring_rowid, ring_cursor, ring_total
#   also returning sqlca.sqlcode != 0 if update failed.
######################################################################
#  This is a function that can be called from the utilities menu.
#  this adds an already m_prepped record.
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer

    # Trap fatal errors
    whenever error call error_handler

    # what a nice program...
    call please_wait()

    # column level data validation (using "validate")
    # Not doing what it is supposed to.  Still call the functions
    # for backward compatibility (and because they call the m_prep),
    # but don't error if failed.
    let status = 0
    let sqlca.sqlcode = 0
    call mlh_validate()
    call mld_validate()

    # Add the header record
    call llh_add()
    if sqlca.sqlcode < 0
    then
        call fg_error("r_menu","r_lladd",2)
        let status = 0
        call ring_view(ring_cursor)
            returning ring_rowid, ring_cursor
        call lib_delkey()  # remove any orphans
        call put_scrlib("scr_key","") # reset key to null
        let sqlca.sqlcode = -1
        return ring_rowid, ring_cursor, ring_total
    end if
    let ring_rowid = sqlca.sqlerrd[6]
    call put_scrlib("curs_rowid",ring_rowid)
    call lib_newkey()  # (possibly) change documents tied to this key
    call lib_chkkey()  # automatically update keyed documents
    call lld_add()
    if sqlca.sqlcode < 0
    then
        call fg_error("r_menu","r_lladd",3)
        call lld_delete()   # clear out partially added detail lines
        let status = 0
        call ring_view(ring_cursor)
            returning ring_rowid, ring_cursor
        let sqlca.sqlcode = -1
        return ring_rowid, ring_cursor, ring_total
    end if
    # identify as a new document
    let ring_cursor = 0
    call put_scrlib("curs_pos",ring_cursor)
    let sqlca.sqlcode = 0
    return ring_rowid, ring_cursor, ring_total
end function
# ring_lladd()
