######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_llupdate.4gl  1.1  Delta: 11/23/90
######################################################################

######################################################################
function ring_llupdate(ring_rowid)
######################################################################
#  This is a function that can be called from the utilities menu.
#  this updates an already m_prepped record
#   also returning sqlca.sqlcode != 0 if update failed.
#
    define
        ring_rowid  integer

    # Trap fatal errors
    whenever error call error_handler

    # what a nice program...
    call please_wait()
    let sqlca.sqlcode = 0

    # Detail line delete must be done before the header m_prep (done
    # in mlh_validate) because it must delete using the OLD key to
    # the data (stored in m_header).
    call lld_delete()   # delete all detail rows from disk
    if sqlca.sqlcode < 0
    then
        call fg_error("r_menu","r_llupdate",1)
        call ring_restore(ring_rowid)
        let sqlca.sqlcode = -1
        return
    end if

    # column level data validation (using "validate")
    # Not doing what it is supposed to.  Still call the functions
    # for backward compatibility (and because they call the m_prep),
    # but don't error if failed.
    call mlh_validate()
    call mld_validate()

    # Write new detail rows to disk
    call lld_add()
    if sqlca.sqlcode < 0
    then
        call fg_error("r_menu","r_llupdate",2)
        call ring_restore(ring_rowid)
        let sqlca.sqlcode = -1
        return
    end if

    # ok, now write and unlock the header record.
    call llh_update(ring_rowid)
    if sqlca.sqlcode < 0 or int_flag != 0
    then
        call fg_error("r_menu","r_llupdate",3)
        call ring_restore(ring_rowid)
        let sqlca.sqlcode = -1
        return
    end if
    call lib_newkey()  # (possibly) change documents tied to this key
    call lib_chkkey()  # Automatically update items keyed to the screen
    let sqlca.sqlcode = 0

end function
# ring_llupdate()
