######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_refresh.4gl  1.1  Delta: 11/23/90
######################################################################

######################################################################
function ring_refresh(ring_rowid)
#   returning ring_rowid
######################################################################
# This function works with the record currently displayed.
# It retrieves the latest copy from the disk.
# It returns:
#       ring_rowid = 0 if notfound
#       ring_rowid = -1 if other disk read problems
#

    define
        ring_rowid  integer     # rowid to return

    # Trap fatal errors
    whenever error call error_handler

    if ring_rowid <= 0 then return ring_rowid end if

    let int_flag = 0
    call mlh_clear()                # clear out all elements in header
    call mld_clear()                # and in detail array
    call llh_read(ring_rowid)       # get the record into m_*
                                    # and into the p_* variables
    case
      when sqlca.sqlcode = notfound or sqlca.sqlcode = -246
        let status = 0
        clear form
        return 0
      when sqlca.sqlcode < 0
        call scr_error("fatal_sql","llh_read()")
    end case
    call lld_read()                 # read in the nln lines
    if sqlca.sqlcode < 0
    then
        if sqlca.sqlcode = -1
          then call scr_error("array","DO NOT UPDATE")
          else call scr_error("sql","in ring_refresh()")
        end if
        clear form
        let int_flag = 0
        return -1
    end if

    # perform any math on the header
    call llh_math()

    # put the p_* variables onto the screen
    call llh_display()
    call lld_display()
    call lib_getkey()  # get the screen key
    return ring_rowid
    let int_flag = 0
end function
# ring_refresh()
