########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_scroll.4gl  1.5  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    arr_mesgs array[2] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)                  # Y/null Message cursor prepared?

######################################################################
function ring_scroll(ring_rowid, ring_cursor, ring_total)
#   returning ring_rowid, ring_cursor, ring_total
######################################################################
#   scrolling browser
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer,
        num_rows    smallint,
        win_width   smallint,
        win_length  smallint,
        curr_line   smallint,       # current line number
        cur_hold    integer,        # holding bin for the current cursor
        quit_flag   smallint,       # indicator to go back w/o selecting
        tempstr     char(40)

    # Trap fatal errors
    whenever error call error_handler

    if mssg_prep is null then
#1: " of "
       call fg_getmsg("lib_scr","rscroll",1)
       let arr_mesgs[1].mssg_text = scratch
#2: " (Deleted)"
       call fg_getmsg("lib_scr","rscroll",2)
       let arr_mesgs[2].mssg_text = scratch
       let mssg_prep = "Y"
    end if

    call brw_open() returning num_rows
    let cur_hold = ring_cursor
    let curr_line = 1

    call menu_line()
    call window_size()
    let win_length = get_scrlib("num_rows")
    let win_width = get_scrlib("num_cols")

    call ring_draw_win(num_rows, ring_cursor, ring_total)

    call ring_highlight(curr_line, ring_cursor)
        returning ring_rowid

    call ring_brw_border(ring_rowid, ring_cursor, ring_total)

    let int_flag = 0
    let quit_flag = 0

# the following is the language independant menu routine in menuscrl.4gl
# which is set up to allow different language menus to be utilized

    call scrl_menu(ring_rowid,ring_cursor,ring_total,curr_line,num_rows)
        returning ring_rowid, ring_cursor, ring_total

    let scr_funct = ""
    call brw_close()
    call window_size()
    # display the last highligted item
    if quit_flag != 0
    then
        let ring_cursor = cur_hold
        let int_flag = 0
    end if
    let menu_item = "find"
    call ring_view(ring_cursor)
        returning ring_rowid, ring_cursor
    return ring_rowid, ring_cursor, ring_total
end function
# ring_scroll()

######################################################################
function ring_brw_border(ring_rowid, ring_cursor, ring_total)
######################################################################
#   browser border
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer

    # Build the screen key
    call lib_getkey()

    # Print the "(Notes)" message if appropriate
    if note_exist(get_scrlib("scr_tab"), get_scrlib("scr_key"))
      then call lib_message("note_on")
      else call lib_message("note_off")
    end if

    let scratch = "(",ring_cursor using "<,<<<,<<<" clipped,
                    arr_mesgs[1].mssg_text clipped, " ",
                    ring_total using "<,<<<,<<<" clipped,")"

    if ring_rowid = 0
      then let scratch = scratch clipped,arr_mesgs[2].mssg_text clipped
    end if

    call lib_message("scr_bottom")

end function
# ring_brw_border()

######################################################################
function ring_draw_win(num_rows, ring_cursor, ring_total)
######################################################################
#   draw a whole window
#
    define
        num_rows    smallint,
        ring_cursor integer,
        ring_total  integer,
        ring_rowid  integer,
        n           smallint

    for n = 1 to num_rows
        call mlh_clear()
        if (ring_cursor + n - 1) <= ring_total
        then
            call ring_fetch(ring_cursor + n - 1)
                returning ring_rowid
        end if
        call brw_display(n, false)
    end for

    return
end function
# ring_draw_win()

######################################################################
function ring_fetch(ring_cursor)
# returning ring_rowid
######################################################################
# This function works with an open cursor.  it fetches the
# element specified by the argument. into the p_variables
#

    define
        ring_cursor integer,    # proposed cursor number
        ring_rowid  integer     # rowid

    let int_flag = 0
    let status = 0
    call mlh_clear()                # clear out all elements in header
    call mlh_fetch_cur(ring_cursor) # fetch rowid into sqlca.sqlerrd[6]
    let ring_rowid = sqlca.sqlerrd[6]
    call llh_read(ring_rowid)       # get the record into m_*
                                    # and into the p_* variables
    case
      when sqlca.sqlcode = notfound or sqlca.sqlcode = -246
        let status = 0
        call mlh_clear()
        return -1
      when sqlca.sqlcode < 0
        call scr_error("fatal_sql","llh_read()")
    end case
    return ring_rowid
end function
# ring_fetch()

######################################################################
function ring_highlight (curr_line, ring_cursor)
# returning ring_rowid
######################################################################
#   - this function works with an open cursor.  it fetches the
#     element specified by the argument into the p_variables
#     then displays it highlighted
#

    define
        curr_line   smallint,   # current line number to highlight
        ring_cursor integer,    # proposed cursor number
        ring_rowid  integer     # return value

    call ring_fetch(ring_cursor)
        returning ring_rowid

    call brw_display(curr_line,true)
    return ring_rowid
end function
# ring_highlight()
