########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_update.4gl  1.4  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    arr_mesgs array[1] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)                  # Y/null Message cursor prepared?

######################################################################
function ring_update(lab_type, ring_rowid)
######################################################################
#
    define
        sql_code    integer,  # sqlca.sqlcode returned from SQL update
        lab_type    integer,
        ring_rowid  integer,
        chk_tab char(18),
        chk_key char(30)

    # Trap fatal errors
    whenever error call error_handler

    if mssg_prep is null then
#1: " Restoring document..."
       call fg_getmsg("lib_scr","rupdate",1)
       let arr_mesgs[1].mssg_text = scratch
       let mssg_prep = "Y"
    end if

    # Disregard the rowid that is passed (retained as an argument
    # for backward compatibility only)
    let ring_rowid = get_scrlib("curs_rowid")

    if ring_rowid = 0
    then
        call fg_error("r_menu","r_update",1)
        return
    end if

    if ring_rowid < 0
    then
        call fg_error("r_menu","r_update",2)
        return
    end if

    # Database transactions
    if is_trx() then begin work end if

    # intelligent update routine
    if ok_update() = false
    then
        if is_trx() then rollback work end if
        return
    end if

    call ring_clear()
    call lib_message("update")
    if lab_type = 2
      then call lib_message("tab")
    end if

    # read, and lock the record
    call mlh_lock(ring_rowid)
    if sqlca.sqlcode != 0
    then
        if sqlca.sqlcode = notfound
          then call fg_error("r_menu","r_update",3)
          else call fg_error("r_menu","r_update",4)
        end if
        let status = 0
        if is_trx() then rollback work end if
        return
    end if

    # record is now locked. call screen input function
    if ring_input() = -1
    then
        call ring_restore(ring_rowid)
        if is_trx() then rollback work end if
        return
    end if

    # call the generic disk update function that can be called
    # from the options menu also.
    # sqlca.sqlcode = -1 if update failed
    call ring_llupdate(ring_rowid)
    let sql_code = sqlca.sqlcode

    # unlock the record
    call mlh_unlock()

    # Commit/Rollback work if trx. used
    if is_trx()
    then
        if sql_code < 0
          then rollback work
          else commit work
        end if
    end if

    return
end function
# ring_update()

######################################################################
function ring_restore(ring_rowid)
######################################################################
    define
        ring_rowid  integer
    message arr_mesgs[1].mssg_text clipped
    clear form
    call mlh_clear()              # clear out the header records
    call mld_clear()              # clear out the detail arrays
    call llh_read(ring_rowid)     # restore the header data
    if sqlca.sqlcode != 0
    then
        if sqlca.sqlcode != notfound and sqlca.sqlcode != -246
          then call scr_error("fatal_sql","llh_read()") end if
        clear form
    else
        call lld_read()               # restore the detail data
        call llh_math()               # recalculate the header
        call llh_display()            # write header to the screen
        call lld_display()            # write detail to the screen
    end if
    call mlh_unlock()             # unlock the header record
    let status = 0
    let int_flag = 0
    sleep 1
    return
end function
# ring_restore()
