######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/r_view.4gl  1.1  Delta: 11/23/90
######################################################################

######################################################################
function ring_view(ring_cursor)
#   returning ring_rowid, ring_cursor
######################################################################
#   - this function works with an open cursor.  it fetches the
#     element specified by the argument.
#    - return:
#       ring_rowid = 0, ring_cursor = ring_cursor if notfound
#       ring_rowid = -1 and ring_cursor = 0 if other disk read problems
#

    define
        ring_cursor integer,    # proposed cursor number
        ring_rowid  integer     # rowid to return

    # Trap fatal errors
    whenever error call error_handler

    call mlh_clear()                # clear out all elements in header
    call mld_clear()                # and in detail array
    # No use doing a read if not pointing to any row
    if ring_cursor < 1
      then return ring_rowid, ring_cursor
    end if
    call mlh_fetch_cur(ring_cursor) # fetch rowid into sqlca.sqlerrd[6]
    let ring_rowid = sqlca.sqlerrd[6]
    call put_scrlib("curs_rowid",ring_rowid)
    call llh_read(ring_rowid)       # get the record into the m_* record
                                    # and into the p_* record
    case
      when sqlca.sqlcode = notfound or sqlca.sqlcode = -246
        clear form
        call put_scrlib("curs_rowid",0)
        return 0, ring_cursor
      when sqlca.sqlcode < 0
        call scr_error("fatal_sql","llh_read()")
    end case
    call lld_read()                 # read in the nln lines
    if sqlca.sqlcode < 0
    then
        call llh_display()
        if sqlca.sqlcode = -1
          then call scr_error("array","exceeded in lld_read()")
          else call scr_error("sql","lld_read in ring_view()")
        end if
        clear form
        let int_flag = 0
        call put_scrlib("curs_rowid",-1)
        call put_scrlib("curs_pos",0)
        return -1, 0
    end if

    # perform any math on the header
    call llh_math()

    # put the p_* variables onto the screen
    call llh_display()
    call lld_display()
    call lib_getkey()               # Build the screen key
    call put_scrlib("curs_rowid",ring_rowid)
    call put_scrlib("curs_pos",ring_cursor)
    return ring_rowid, ring_cursor
    let int_flag = 0
end function
# ring_view()
