########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/scr_err.4gl  1.4  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    arr_mesgs array[8] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)                  # Y/null Message cursor prepared?

######################################################################
function scr_error(err_type,err_txt)
######################################################################
# This is the error handling routine for screen errors known to
# the code generator.
#
    define
        err_type char(15),  # type of screen error
        err_txt char(75),   # text of error
        err_mod char(8),    # program module
        err_prog char(8)    # program name

    # Trap fatal errors
    whenever error call error_handler

    if mssg_prep is null then
#1: "Window name: "
       call fg_getmsg("lib_scr","screror",1)
       let arr_mesgs[1].mssg_text = scratch
#2: "Maximum elements = "
       call fg_getmsg("lib_scr","screror",2)
       let arr_mesgs[2].mssg_text = scratch
#3: "Maximum elements = "
       call fg_getmsg("lib_scr","screror",3)
       let arr_mesgs[3].mssg_text = scratch
#4: "Column: '"
       call fg_getmsg("lib_scr","screror",4)
       let arr_mesgs[4].mssg_text = scratch
#5: "Lookup table: '" --used twice--
       call fg_getmsg("lib_scr","screror",5)
       let arr_mesgs[5].mssg_text = scratch
#6: "Program error at "
       call fg_getmsg("lib_scr","screror",6)
       let arr_mesgs[6].mssg_text = scratch
#7: "SQL statement error number"
       call fg_getmsg("lib_scr","screror",7)
       let arr_mesgs[7].mssg_text = scratch
#8: "Fatal SQL error in: "
       call fg_getmsg("lib_scr","screror",8)
       let arr_mesgs[8].mssg_text = scratch
    let mssg_prep = "Y"
    end if

    case
      when err_type is null # Browse all defined errors
        call get_mod() returning err_mod, err_prog
        # Use the scr_id as the err_prog unless in default screen
        if scr_id != "default" then let err_prog = scr_id end if
        call lib_error(err_mod,err_prog,0,"")
      when err_type = "sql"
        call lib_error("lib_scr","sql",1,err_txt)
      when err_type = "recursive"
        let scratch = arr_mesgs[1].mssg_text clipped, err_txt clipped
        call lib_error("lib_scr","recursiv",1,"(see scratch)")
      when err_type = "array"
        # Maximum elements passed as error text
        let scratch = arr_mesgs[2].mssg_text clipped, err_txt clipped
        call lib_error("lib_scr", "array", 1, "(see scratch)")
      when err_type = "overflow"
        # Maximum elements passed as error text
        let scratch = arr_mesgs[3].mssg_text clipped, err_txt clipped
        call lib_error("lib_scr", "zoom", 1, "(see scratch)")
      when err_type = "dupchk"
        let scratch = arr_mesgs[4].mssg_text clipped, err_txt clipped, "'."
        call lib_error("lib_scr", "dupchk", 1, "(see scratch)")
      when err_type = "lookup=notfound"
        let scratch = arr_mesgs[5].mssg_text clipped, err_txt clipped, "'."
        call lib_error("lib_scr", "lookup", 1, "(see scratch)")
      when err_type = "lookup=error"
        let scratch = arr_mesgs[5].mssg_text clipped, err_txt clipped, "'."
        call lib_error("lib_scr", "lookup", 2, "(see scratch)")
      when err_type = "fatal_sql"
        # Fatal sql errors are called when you HAVE to put the
        # 'whenever error continue' loop around an SQL statement,
        # and status < 0, but it isn't something that you know about.
        # This error will automatically log, and exit the program.
        # The err_text that you pass should point to the function
        # name that this fatal error occured.
        let scratch = arr_mesgs[6].mssg_text clipped, err_txt clipped, "\n",
          arr_mesgs[7].mssg_text clipped, sqlca.sqlcode using "-<<<<.",
          "\n", err_get(sqlca.sqlcode)
        call errorlog(scratch[1,512])
        let scratch = arr_mesgs[8].mssg_text clipped, err_txt
        call lib_error("lib_scr", "errhand", 1, "(see scratch)")
        exit program(1)
    end case
    let status = 0

end function
# scr_error()
