######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../scr.4gs/scr_lib.4gl  1.3  Delta: 1/22/91
######################################################################

globals "globals.4gl"

# Local library variables (used for the get/put operations)
define
    auto_note char(1),   # Automatically update freeform notes?      Y/N
    auto_udf char(1),    # Automatically update user defined fields? Y/N
    auto_answr char(1),  # Automatically answer Y/N to all prompts
    curs_count integer,  # number of elements in browse cursor
    curs_pos integer,    # current browse cursor position
    curs_rowid integer,  # rowid of current document
    custom char(3),      # custom source code
    dbname char(10),     # current database name
    fld_tab char(18),    # current screen field's table table
    language char(3),    # language code
    module char(8),      # module name
    num_cols smallint,   # number of columns (chars) in this screen
    num_rows smallint,   # number of rows (lines) in this screen
    scr_key char(30),    # screen key
    scr_tab char(18),    # main screen table
    scr_type char(20),   # type of screen
    version char(8)      # current version of the generated code

######################################################################
function put_scrlib(var,value)
######################################################################
# This function puts the specified value into the specified variable.
# The variables used here are "local" to the FourGen:Screen library,
# however, they can be accessed anywhere within the application.
# If value = "(see scratch)", then the value to assign var is over
# 30 characters and can be found in the scratch variable.
#
    define
        var char(10),   # variable to assign
        value char(100) # value to assign that variable

    # Trap fatal errors
    whenever error call error_handler

    # Move the value into scratch
    if value = "(see scratch)" then let value = scratch end if

    # Assign the appropriate variable with the contents of value
    case

      when var = "auto_note" let auto_note = value
      when var = "auto_udf" let auto_udf = value
      when var = "auto_answr" let auto_answr = value
      when var = "curs_count" let curs_count = value
      when var = "curs_pos" let curs_pos = value
      when var = "curs_rowid" let curs_rowid = value
      when var = "custom" let custom = value
      when var = "dbname" let dbname = value
      when var = "fld_tab" let fld_tab = value
      when var = "language" let language = value
      when var = "module" let module = value
      when var = "num_cols" let num_cols = value
      when var = "num_rows" let num_rows = value
      when var = "scr_key" let scr_key = value
      when var = "scr_tab" let scr_tab = value
      when var = "scr_type" let scr_type = value
      when var = "version" let version = value

    end case
    return
end function
# put_scrlib()

######################################################################
function get_scrlib(var)
# returning value
######################################################################
# This function gets the specified value from the local FourGen:Screen
# variable, and returns it to the calling function.  If the string
# is too big to return, it will place it into the scratch variable
# and return "(see scratch)".
#
    define
        var char(10)   # variable to return

    # Return the appropriate variable
    case

      when var = "auto_note" return auto_note
      when var = "auto_udf" return auto_udf
      when var = "auto_answr" return auto_answr
      when var = "curs_count" return curs_count
      when var = "curs_pos" return curs_pos
      when var = "curs_rowid" return curs_rowid
      when var = "custom" return custom
      when var = "dbname" return dbname
      when var = "fld_tab" return fld_tab
      when var = "language" return language
      when var = "module" return module
      when var = "num_cols" return num_cols
      when var = "num_rows" return num_rows
      when var = "scr_key" return scr_key
      when var = "scr_tab" return scr_tab
      when var = "scr_type" return scr_type
      when var = "version" return version

    end case
    return ""
end function
# get_scrlib()
